searchNodes=[{"doc":"/ni:mi:/ - Snapshot testing for Elixir ExUnit Early days Mneme is fairly new. Please feel free to submit any feedback, bugs, or suggestions as issues on Github . Thanks! Snapshot tests assert that some expression matches a reference value. It's like an ExUnit assert , except that the reference value is managed for you by Mneme. Mneme follows in the footsteps of existing snapshot testing libraries like Insta (Rust), expect-test (OCaml), and assert_value (Elixir). Instead of simple value or string comparison, however, Mneme leans heavily into pattern matching. Example Let's say you've written a test for a function that removes even numbers from a list: test &quot;drop_evens/1 should remove all even numbers from an enum&quot; do auto_assert drop_evens ( 1 .. 10 ) auto_assert drop_evens ( [ ] ) auto_assert drop_evens ( [ :a , :b , 2 , :c ] ) end The first time you run this test, you'll see interactive prompts for each call to auto_assert showing a diff and asking if you'd like to accept the generated pattern. After accepting them, your test is updated: test &quot;drop_evens/1 should remove all even numbers from an enum&quot; do auto_assert [ 1 , 3 , 5 , 7 , 9 ] &lt;- drop_evens ( 1 .. 10 ) auto_assert [ ] &lt;- drop_evens ( [ ] ) auto_assert [ :a , :b , :c ] &lt;- drop_evens ( [ :a , :b , 2 , :c ] ) end The next time you run this test, you won't receive a prompt and these will act (almost) like any other assertion. If the result of the call ever changes, you'll be prompted again and can choose to update the test or reject it and let it fail. With a few exceptions, auto_assert/1 acts very similarly to a normal assert . See the macro docs for a list of differences. Quick start Add :mneme do your deps in mix.exs : defp deps do [ { :mneme , &quot;&gt;= 0.0.0&quot; , only : :test } ] end Add :mneme to your :import_deps in .formatter.exs : [ import_deps : [ :mneme ] , inputs : [ &quot;{mix,.formatter}.exs&quot; , &quot;{config,lib,test}/**/*.{ex,exs}&quot; ] ] Start Mneme right after you start ExUnit in test/test_helper.exs : ExUnit . start ( ) Mneme . start ( ) Add use Mneme wherever you use ExUnit.Case : defmodule MyTest do use ExUnit.Case , async : true use Mneme test &quot;arithmetic&quot; do # use auto_assert instead of ExUnit&#39;s assert - run this test # and delight in all the typing you don&#39;t have to do auto_assert 2 + 2 end end Match patterns Mneme tries to generate match patterns that are equivalent to what a human (or at least a nice LLM) would write. Basic data types like strings, numbers, lists, tuples, etc. will be as you would expect. Some values, however, do not have a literal representation that can be used in a pattern match. Pids are such an example. For those, guards are used: auto_assert self ( ) # after running the test and accepting the change auto_assert pid when is_pid ( pid ) &lt;- self ( ) Additionally, local variables can be found and pinned as a part of the pattern. This keeps the number of hard-coded values down, reducing the likelihood that tests have to be updated in the future. test &quot;create_post/1 creates a new post with valid attrs&quot; , %{ user : user } do valid_attrs = %{ title : &quot;my_post&quot; , author : user } auto_assert create_post ( valid_attrs ) end # after running the test test &quot;create_post/1 creates a new post with valid attrs&quot; , %{ user : user } do valid_attrs = %{ title : &quot;my_post&quot; , author : user } auto_assert { :ok , % Post { title : &quot;my_post&quot; , author : ^ user } } &lt;- create_post ( valid_attrs ) end In many cases, multiple valid patterns will be possible. Usually, the &quot;simplest&quot; pattern will be selected by default when you are prompted, but you can cycle through the options as well. Non-exhaustive list of special cases Pinned variables are generated by default if a value is equal to a variable in scope. Date and time values are written using their sigil representation. Struct patterns only include fields that are different from the struct defaults. Structs defined by Ecto schemas exclude primary keys, association foreign keys, and auto generated fields like :inserted_at and :updated_at . This is because these fields are often randomly generated and would fail on subsequent tests. Formatting Mneme uses Rewrite to update source code, formatting that code before saving the file. Currently, the Elixir formatter and FreedomFormatter are supported. If you do not use a formatter, the first auto-assertion will reformat the entire file. Continuous Integration In a CI environment, Mneme will not attempt to prompt and update any assertions, but will instead fail any tests that would update. This behavior is enabled by the CI environment variable, which is set by convention by many continuous integration providers. export CI=true Editor support Guides for optional editor integration can be found here: VS Code Acknowledgements Special thanks to: What if writing tests was a joyful experience? , from the Jane Street Tech Blog, for inspiring this library. Sourceror , a library that makes complex code modifications simple. Rewrite , which provides the diff functionality present in Mneme. Owl , which makes it much easier to build a pretty CLI. Insta , a snapshot testing tool for Rust, whose great documentation provided an excellent reference for snapshot testing. assert_value , an existing Elixir project that provides similar functionality. Thank you for paving the way! Configuration Mneme can be configured globally in your application config, usually config/test.exs . config :mneme , defaults : [ default_pattern : :last ] Configuration can also be set at the module level with use Mneme , in a describe block with @mneme_describe or for an individual test using @mneme . defmodule MyTest do use ExUnit.Case # reject all changes to auto-assertions by default use Mneme , action : :reject test &quot;this test will fail&quot; do auto_assert 1 + 1 end describe &quot;some describe block&quot; do # accept all changes to auto-assertions in this describe block @mneme_describe action : :accept test &quot;this will update without prompting&quot; do auto_assert 2 + 2 end # prompt for any changes in this test @mneme action : :prompt test &quot;this will prompt before updating&quot; do auto_assert 3 + 3 end end end Configuration that is &quot;closer to the test&quot; will override more general configuration: @mneme &gt; @mneme_describe &gt; use Mneme &gt; config :mneme The exception to this is the CI environment variable, which causes all updates to be rejected. See the &quot;Continuous Integration&quot; section for more info. Options :action - The action to be taken when an auto-assertion updates. Actions are one of :prompt , :accept , or :reject . If CI=true is set in environment variables, the action will always be :reject . The default value is :prompt . :default_pattern - The default pattern to be selected if prompted to update an assertion. Can be one of :infer , :first , or :last . The default value is :infer . :diff - Controls the diff engine used to display changes when an auto- assertion updates. If :semantic , uses a custom diff engine to highlight only meaningful changes in the value. If :text , uses the Myers Difference algorithm to highlight all changes in text. The default value is :semantic . :diff_style - Controls how diffs are rendered when the :diff option is set to :semantic . If :side_by_side , old and new code will be rendered side-by-side if the terminal has sufficient space. If :stacked , old and new code will be rendered one on top of the other. The default value is :side_by_side . :force_update ( boolean/0 ) - Setting to true will force auto-assertions to update even when they would otherwise succeed. This can be especially helpful when adding new keys to maps or structs since a pattern like %{} would not normally prompt as the match still succeeds. The default value is false . :target - The target output for auto-assertions. If :mneme , the expression will remain an auto-assertion. If :ex_unit , the expression will be rewritten as an ExUnit assertion. The default value is :mneme .","ref":"Mneme.html","title":"Mneme","type":"module"},{"doc":"Sets up Mneme configuration for this module and imports auto-assertion macros. This macro accepts all options described in the &quot;Configuration&quot; section above. Example defmodule MyTest do use ExUnit.Case use Mneme # &lt;- add this test &quot;...&quot; do auto_assert ... end end","ref":"Mneme.html#__using__/1","title":"Mneme.__using__/1","type":"macro"},{"doc":"Pattern-generating variant of ExUnit.Assertions.assert/1 . Examples auto_assert generates assertions when tests run, issuing a terminal prompt before making any changes (unless configured otherwise). auto_assert [ 1 , 2 ] ++ [ 3 , 4 ] # after running the test and accepting the change auto_assert [ 1 , 2 , 3 , 4 ] &lt;- [ 1 , 2 ] ++ [ 3 , 4 ] If the match no longer succeeds, a warning and new prompt will be issued to update it to the new value. auto_assert [ 1 , 2 , 3 , 4 ] &lt;- [ 1 , 2 ] ++ [ :a , :b ] # after running the test and accepting the change auto_assert [ 1 , 2 , :a , :b ] &lt;- [ 1 , 2 ] ++ [ :a , :b ] Prompts are only issued if the pattern doesn't match the value, so that pattern can also be changed manually. # this assertion succeeds, so no prompt is issued auto_assert [ 1 , 2 , | _ ] &lt;- [ 1 , 2 ] ++ [ :a , :b ] Differences from ExUnit assert The auto_assert macro is meant to match assert very closely, but there are a few differences to note: Pattern-matching assertions use the &lt;- operator instead of the = match operator. Unlike ExUnit's assert , auto_assert can match falsy values. The following are equivalent: falsy = nil auto_assert nil &lt;- falsy assert falsy == nil Guards can be added with a when clause, while assert would require a second assertion. For example: auto_assert pid when is_pid ( pid ) &lt;- self ( ) assert pid = self ( ) assert is_pid ( pid ) Bindings in an auto_assert are not available outside of that assertion. For example: auto_assert pid when is_pid ( pid ) &lt;- self ( ) pid # ERROR: pid is not bound If you need to use the result of the assertion, it will evaluate to the expression's value. pid = auto_assert pid when is_pid ( pid ) &lt;- self ( ) pid # pid is the result of self()","ref":"Mneme.html#auto_assert/1","title":"Mneme.auto_assert/1","type":"macro"},{"doc":"See auto_assert_raise/3 .","ref":"Mneme.html#auto_assert_raise/1","title":"Mneme.auto_assert_raise/1","type":"macro"},{"doc":"See auto_assert_raise/3 .","ref":"Mneme.html#auto_assert_raise/2","title":"Mneme.auto_assert_raise/2","type":"macro"},{"doc":"Pattern-generating variant of ExUnit.Assertions.assert_raise/3 . If the given function does not raise, the assertion will fail. Like auto_assert/1 , you will be prompted to automatically update the assertion if the raised raised exception changes. Examples You can pass an anonymous function that takes no arguments and is expected to raise an exception. auto_assert_raise fn -&gt; some_call_expected_to_raise ( ) end # after running the test and accepting changes auto_assert_raise Some.Exception , fn -&gt; some_call_expected_to_raise ( ) end # optionally include the message auto_assert_raise Some.Exception , &quot;perhaps with a message&quot; , fn -&gt; some_call_expected_to_raise ( ) end A captured function of arity zero can also be used. auto_assert_raise &amp; some_call_expected_to_raise / 0 # after running the test and accepting changes auto_assert_raise Some.Exception , &amp; some_call_expected_to_raise / 0","ref":"Mneme.html#auto_assert_raise/3","title":"Mneme.auto_assert_raise/3","type":"macro"},{"doc":"See auto_assert_receive/2 .","ref":"Mneme.html#auto_assert_receive/0","title":"Mneme.auto_assert_receive/0","type":"macro"},{"doc":"See auto_assert_receive/2 .","ref":"Mneme.html#auto_assert_receive/1","title":"Mneme.auto_assert_receive/1","type":"macro"},{"doc":"Pattern-generating variant of ExUnit.Assertions.assert_receive/3 . timeout is in milliseconds and defaults to 100 . Examples Process . send_after ( self ( ) , { :some , :message } , 50 ) auto_assert_receive ( ) # after running the test, messages appearing within 100ms # will be available as options auto_assert_receive { :some , :message } A custom timeout can be specified as a second argument. Process . send_after ( self ( ) , { :some , :message } , 150 ) auto_assert_receive nil , 300 # messages appearing within 300ms will now appear as options auto_assert_receive { :some , :message } , 300","ref":"Mneme.html#auto_assert_receive/2","title":"Mneme.auto_assert_receive/2","type":"macro"},{"doc":"See auto_assert_received/1 .","ref":"Mneme.html#auto_assert_received/0","title":"Mneme.auto_assert_received/0","type":"macro"},{"doc":"Pattern-generating variant of ExUnit.Assertions.assert_received/2 . Similar to auto_assert_receive/2 , except that the timeout is set to 0, so the expected message must already be in the current process' mailbox. Examples send ( self ( ) , { :some , :message } ) auto_assert_received ( ) # after running the test, messages in the current process # inbox will be available as options auto_assert_receive { :some , :message }","ref":"Mneme.html#auto_assert_received/1","title":"Mneme.auto_assert_received/1","type":"macro"},{"doc":"Starts Mneme to run auto-assertions as they appear in your tests. This will almost always be added to your test/test_helper.exs , just below the call to ExUnit.start() : # test/test_helper.exs ExUnit . start ( ) Mneme . start ( ) Options :restart (boolean) - Restarts Mneme if it has previously been started. This option enables certain IEx-based testing workflows that allow tests to be run without a startup penalty. Defaults to false .","ref":"Mneme.html#start/1","title":"Mneme.start/1","type":"function"},{"doc":"","ref":"Mneme.AssertionError.html","title":"Mneme.AssertionError","type":"exception"},{"doc":"","ref":"Mneme.CompileError.html","title":"Mneme.CompileError","type":"exception"},{"doc":"","ref":"Mneme.InternalError.html","title":"Mneme.InternalError","type":"exception"},{"doc":"This project adheres to Semantic Versioning .","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"It is now recommended to use Elixir v1.14.4 or later. Breaking changes [Core] auto_assert now uses &lt;- when comparing against falsy values instead of == . Support for comparisons using == has been removed. Enhancements [Core] Add three new auto-assertions: auto_assert_raise auto_assert_receive auto_assert_received [Core] Add a :force_update option that forces re-generating assertion patterns even when they succeed. See the Options documentation for more info. [Core] Existing auto-assertions will now run when Mneme.start() is not called, but new or failing auto-assertions will fail without prompting ( #32 ). [Core] Pattern generation improvements: Ranges now use range syntax like 1..10 and 1..10//2 instead of generating a %Range{} struct. [CLI] Prompts will now show options that were overridden from the defaults. [CLI] Mneme now prints a one-line summary at the end of the test run. Fixes [Core] Fix a configuration precedence bug that caused options set in application config to always override module, describe, or test options. [Core] Fix a compatibility issue with Ecto ~&gt; 3.9.4 ( #34 ). [CLI] Fix a confusing diff result that could occur with some binary operations ( #11 ). [CLI] Preceding comments are no longer shown in diffs ( #26 ). [CLI] Fix a number of diffing errors related to structs.","ref":"changelog.html#v0-3-0-2023-04-10","title":"Changelog - v0.3.0 (2023-04-10)","type":"extras"},{"doc":"Fixes Fix a crash related to escaped string interpolation characters ( #29 ).","ref":"changelog.html#v0-2-7-2023-03-29","title":"Changelog - v0.2.7 (2023-03-29)","type":"extras"},{"doc":"Enhancements Auto-assertion prompts can now be skipped ( s ) in addition to accepted ( y ) or rejected ( n ). This allows the test clause to continue so that later assertions might be run, but fails the test run once the suite finishes. Updated formatting for semantic diffs: Diffs will be displayed side-by-side if terminal width allows. To always display diffs stacked, use the diff_style: :stacked option; see the &quot;Configuration&quot; section of the Mneme module doc for more. Both :stacked and :side_by_side diffs have updated, more consistent formatting. Fixes Don't overwrite test files if their content changes after starting the test run ( #23 ). Fix a crash that occurred when a value contained nested strings with newlines, e.g. {:ok, &quot;hello\\nworld&quot;} ( #25 ). The j/k options will no longer be rendered when prompting if there is only a single pattern option.","ref":"changelog.html#v0-2-6-2023-03-27","title":"Changelog - v0.2.6 (2023-03-27)","type":"extras"},{"doc":"Fixes Remove unnecessary files from Hex package. This cuts the package size down drastically.","ref":"changelog.html#v0-2-4-v0-2-5-2023-03-25","title":"Changelog - v0.2.4, v0.2.5 (2023-03-25)","type":"extras"},{"doc":"Fixes Fix diffing for certain sigil variations. Fix dbg -related error when running MIX_ENV=test iex -S mix ( #20 ). Fix ETS-related error when calling Mneme.start/1 multiple times ( #20 ).","ref":"changelog.html#v0-2-3-2023-03-25","title":"Changelog - v0.2.3 (2023-03-25)","type":"extras"},{"doc":"Fixes Disable a semantic diffing optimization that caused poor diff results in certain cases, usually manifesting as incorrect branches being compared.","ref":"changelog.html#v0-2-2-2023-03-20","title":"Changelog - v0.2.2 (2023-03-20)","type":"extras"},{"doc":"Enhancements More consistent formatting between :semantic and :text diffs.","ref":"changelog.html#v0-2-1-2023-03-19","title":"Changelog - v0.2.1 (2023-03-19)","type":"extras"},{"doc":"Breaking Mneme now requires Elixir v1.14 or later. Enhancements Adds semantic diffs which selectively highlight only meaningful changes when updating an assertion. This can be disabled with the diff: :text option; see the &quot;Configuration&quot; section of the Mneme module doc for more. Fixes Invalid options now cause a warning instead of crashing test process. Internal errors now show an error instead of crashing test process. Fix bug causing multiple identical choices to be presented in some cases where empty lists were a part of the value.","ref":"changelog.html#v0-2-0-2023-03-18","title":"Changelog - v0.2.0 (2023-03-18)","type":"extras"},{"doc":"Enhancements Improved compile-time error message when auto_assert is used outside of a test block ( #9 ).","ref":"changelog.html#v0-1-6-2023-03-04","title":"Changelog - v0.1.6 (2023-03-04)","type":"extras"},{"doc":"Enhancements More consistent handling of charlists: lists of integers will now generate themselves as a pattern as well as a charlist if the list is ASCII printable ( #6 ).","ref":"changelog.html#v0-1-5-2023-02-25","title":"Changelog - v0.1.5 (2023-02-25)","type":"extras"},{"doc":"Fixes Fix a bug that could cause auto_assert expressions to revert to the previous value when using Mneme.start(restart: true) ( #7 ).","ref":"changelog.html#v0-1-4-2023-02-23","title":"Changelog - v0.1.4 (2023-02-23)","type":"extras"},{"doc":"Enhancements Add a :default_pattern configuration option for auto-assertions which controls the pattern that should be selected by default when prompted. Fixes When converting an auto-assertion to an ExUnit assertion, select the identical pattern when the :default_pattern is :infer (set by default).","ref":"changelog.html#v0-1-3-2023-02-22","title":"Changelog - v0.1.3 (2023-02-22)","type":"extras"},{"doc":"Enhancements Add a :restart option to Mneme.start/1 to restart Mneme if called multiple times.","ref":"changelog.html#v0-1-2-2023-02-21","title":"Changelog - v0.1.2 (2023-02-21)","type":"extras"},{"doc":"Enhancements Dramatically reduce the performance gap between auto_assert and ExUnit's assert .","ref":"changelog.html#v0-1-1-2023-02-20","title":"Changelog - v0.1.1 (2023-02-20)","type":"extras"},{"doc":"First release.","ref":"changelog.html#v0-1-0-2023-02-19","title":"Changelog - v0.1.0 (2023-02-19)","type":"extras"},{"doc":"If you are using Visual Studio Code and the ElixirLS extension, there are a couple of things that you can do to smooth out the workflow of running and updating your tests. The ElixirLS extension comes with some built-in tasks to run tests: mix: Run tests mix: Run tests in current file mix: Run test at cursor These are accessible by running the command Run task and then typing typing one of the tasks. By default, these will open a terminal panel, but will not focus it, which isn't optimal as Mneme requires input when something changes. We can bind these tasks to a keyboard shortcut globally and then update the focus defaults on a per-project basis.","ref":"vscode_setup.html","title":"VS Code","type":"extras"},{"doc":"Run the command Preferences: Open Keyboard Shortcuts (JSON) , then copy the following keyboard shortcuts to the bottom of the list: { &quot;key&quot; : &quot;ctrl+space a&quot; , &quot;command&quot; : &quot;workbench.action.tasks.runTask&quot; , &quot;args&quot; : &quot;mix: Run tests&quot; } , { &quot;key&quot; : &quot;ctrl+space f&quot; , &quot;command&quot; : &quot;workbench.action.tasks.runTask&quot; , &quot;args&quot; : &quot;mix: Run tests in current file&quot; } , { &quot;key&quot; : &quot;ctrl+space c&quot; , &quot;command&quot; : &quot;workbench.action.tasks.runTask&quot; , &quot;args&quot; : &quot;mix: Run test at cursor&quot; } , You can replace &quot;key&quot; with whatever you'd prefer.","ref":"vscode_setup.html#keyboard-shortcuts","title":"VS Code - Keyboard shortcuts","type":"extras"},{"doc":"Tasks provided by extensions can be modified by adding a .vscode/tasks.json to your project's root. The following will modify the tasks listed above to give input focus to the panel they're run in. { &quot;version&quot; : &quot;2.0.0&quot; , &quot;tasks&quot; : [ { &quot;group&quot; : &quot;test&quot; , &quot;type&quot; : &quot;mix&quot; , &quot;task&quot; : &quot;Run tests&quot; , &quot;presentation&quot; : { &quot;focus&quot; : true , } , } , { &quot;group&quot; : &quot;test&quot; , &quot;type&quot; : &quot;mix&quot; , &quot;task&quot; : &quot;Run tests in current file&quot; , &quot;presentation&quot; : { &quot;focus&quot; : true , } , } , { &quot;group&quot; : &quot;test&quot; , &quot;type&quot; : &quot;mix&quot; , &quot;task&quot; : &quot;Run test at cursor&quot; , &quot;presentation&quot; : { &quot;focus&quot; : true , } , } , ] , } The Mneme repository has this set up here , for example.","ref":"vscode_setup.html#per-project-task-defaults","title":"VS Code - Per-project task defaults","type":"extras"}]